-- CONFIGURATION ----------------------------------

hunter = true
paladin = true
priest = true
rogue = true
warlock = true
warrior = true

show_background = true	-- If false only shows the line

-- END OF CONFIG ----------------------------------


-- Should we load addon for this character?
local _, class = UnitClass("player")
if ((hunter == true) and (class == "HUNTER")) or ((paladin == true) and (class == "PALADIN")) or ((priest == true) and (class == "PRIEST"))
or ((rogue == true) and (class == "ROGUE")) or ((warlock == true) and (class == "WARLOCK")) or ((warrior == true) and (class == "WARRIOR")) then

	local holder = CreateFrame("Frame"), function() end

	-- Line
	local ExecuteIndicator = CreateFrame("Frame", "ExecuteIndicatorLine", TargetFrame)
	ExecuteIndicator:SetWidth(2)
	ExecuteIndicator:SetHeight(8)

	-- Background
	local ExecuteIndicatorBG = CreateFrame("Frame", "ExecuteIndicatorBox", TargetFrame)
	ExecuteIndicatorBG:SetHeight(7)
	ExecuteIndicatorBG:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 7, -44)

	-- Texturize!
	ExecuteIndicator.texture = ExecuteIndicator:CreateTexture()
	ExecuteIndicator.texture:SetAllPoints(ExecuteIndicator)
	ExecuteIndicator.texture:SetTexture(0, 0, 0, 0.4)

	ExecuteIndicatorBG.texture = ExecuteIndicatorBG:CreateTexture()
	ExecuteIndicatorBG.texture:SetAllPoints(ExecuteIndicatorBG)
	ExecuteIndicatorBG.texture:SetTexture(1, 0, 0, 0.1)

	-- Should we should load the background?
	local function Background()
		if show_background == true then
			ExecuteIndicatorBG:Show()
		end
	end

	-- Set up indicator
	holder:SetScript("OnEvent", function(holder, event, ...)
		local talentTree = GetPrimaryTalentTree()

		-- No indicator
		ExecuteIndicator:Hide()
		ExecuteIndicatorBG:Hide()

		-- Hunter (20%)
		if (hunter == true) and (class == "HUNTER") then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 29, -43)
			ExecuteIndicatorBG:SetWidth(22)
			ExecuteIndicator:Show()
			Background()
		end

		-- Paladin, Retribution (20%)
		if (paladin == true) and (class == "PALADIN") and (talentTree == 3) then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 29, -43)
			ExecuteIndicatorBG:SetWidth(22)
			ExecuteIndicator:Show()
			Background()
		end

		-- Priest, Shadow (25%)
		if (priest == true) and (class == "PRIEST") and (talentTree == 3) then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 35, -43)
			ExecuteIndicatorBG:SetWidth(28)
			ExecuteIndicator:Show()
			Background()
		end

		-- Rogue, Assassin (35%)
		if (rogue == true) and (class == "ROGUE") and (talentTree == 1) then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 46, -43)
			ExecuteIndicatorBG:SetWidth(40)
			ExecuteIndicator:Show()
			Background()
		end

		-- Warlock (25%)
		if (warlock == true) and (class == "WARLOCK") then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 35, -43)
			ExecuteIndicatorBG:SetWidth(28)
			ExecuteIndicator:Show()
			Background()
		end

		-- Warrior (20%)
		if (warrior == true) and (class == "WARRIOR") then
			ExecuteIndicator:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 29, -43)
			ExecuteIndicatorBG:SetWidth(22)
			ExecuteIndicator:Show()
			Background()
		end
	end)

	holder:RegisterEvent("PLAYER_TALENT_UPDATE")
end